
Core - Task # 54251

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Bug # 52949 (Resolved): Speed decrease since 4.5

Status: Resolved Priority: Should have
Author: Markus Klein Category: Performance
Created: 2013-12-06 Assigned To: Markus Klein
Updated: 2014-01-08 Due date:
TYPO3 Version: 6.2
PHP Version: 5.5
Complexity: easy
Sprint Focus:
Subject: GeneralUtility::array_merge_recursive_overrule has bad performance
Description

According to my profiling activities, GeneralUtility::array_merge_recursive_overrule has really bad performance. (~ 111 ms own time
for a BE call, that ranks number 3 in the list of the most expensive calls based on own time sorting.)
Some tests show that this is due to many array copy actions during the recursive calls (foreach constructs with $val being a copy of
possibly large subarrays).
I propose to optimize this method by:
    1. making the first parameter by reference thus working on the original array
    2. move the function from GeneralUtility to ArrayUtility
    3. deprecate the function in GeneralUtility, but still work on a copy of the first array there to preserve backwards compatibility
    4. change all calls in core to use the new method

This brings the own time of the function down to 42 ms on my test system, getting the function out of the expensive calls in TYPO3
CMS.

Related issues:
related to Core - Task # 57499: Improve deprecation message of GeneralUtitlit... Resolved 2014-04-01
related to Core - Bug # 63812: Lower memory use in ArrayUtil->mergeRecursiveW... Resolved 2014-12-12

Associated revisions
Revision 2917b074 - 2014-01-08 13:13 - Markus Klein

[TASK] Improve performance of array_merge_recursive_overrule

The method GeneralUtility::array_merge_recursive_overrule()
always works on a copy of the given array(s). This is highly
inefficient when it comes to really big arrays and recursion.

This patches moves the functionality into the class ArrayUtility
and changes the behaviour to use a reference to the
original array.
All calls in the core are adjusted accordingly.

Furthermore we deprecate the method in GeneralUtility and
preserve backward compatibility.

Resolves: #54251
Releases: 6.2
Change-Id: I5499905593c2124897de5998be985e546a3d05ee
Reviewed-on: https://review.typo3.org/25986
Reviewed-by: Michiel Roos
Tested-by: Michiel Roos
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Ernesto Baschny
Tested-by: Ernesto Baschny

History
#1 - 2013-12-06 22:43 - Markus Klein
- Parent task set to #52949

#2 - 2013-12-06 23:05 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#3 - 2013-12-06 23:08 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#4 - 2013-12-07 17:10 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#5 - 2013-12-09 12:03 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#6 - 2013-12-09 14:05 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#7 - 2013-12-09 15:02 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#8 - 2013-12-17 00:07 - Gerrit Code Review
Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#9 - 2013-12-19 01:06 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#10 - 2013-12-29 17:02 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#11 - 2013-12-29 17:04 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25986

#12 - 2014-01-08 13:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2917b0745dbe038c10e13f5910776dfb02371b12.
